#-*- coding:utf-8 -*-

class Sommet:
    " ma classe sommet... vide"

# un sommet contiendra
#   - l'info pour savoir si c'est a l'IA de jouer 
#   - le nombre d'allumettes restantes
def creerSommet(IA,n):
    s=Sommet()
    s.IA = IA
    s.n = n
    s.evaluation = None
    s.fils = []

    return s

# Fonction qui ajoute un fils au sommet s de l'arbre
def ajouterFils(s, new):
    s.fils.append(new)

def afficher(racine):
    aFaire = []
    aFaire.append(racine)

    while not aFaire ==[]:
        courant = aFaire[0]

        print [courant.IA, courant.n, courant.evaluation]

        for f in courant.fils :
            aFaire.append(f)

        aFaire.remove(courant)


# version 0 de l'IA : elle retire toujours une allumette
def IA(n):
    return 1


# evaluer un sommet racine :
def evaluation(racine):
    # le seul cas que je sais gerer : n=0
    if racine.n==0 :
        if racine.IA :  # c'est a l'IA de jouer : gagné
           racine.evaluation = 1

            
        else :          # c'est a l'adversaire de joué : dommage
           racine.evaluation = 0
    else :
        # quand je ne sais pas gerer, ce sont les sous arbres qui me donneront l'evaluation
        evaluationFils = []
        for f in racine.fils:
            evaluation(f)
            evaluationFils.append(f.evaluation)

        # Les fils etants evalues, je peux evaluer ma configuration
        if racine.IA :  # le prochain coup est le mien
            # je vais chercher le meilleur coup.
            racine.evaluation =  max(evaluationFils)
        else :
            # le prochain coup est celui de l'adversaire.
            # Il va chercher le meilleur coup, pour lui (le pire pour moi)
            racine.evaluation = min(evaluationFils)
            

# version 1 de l'IA : elle fait du min max.
def IA1( n):
    racine = creerSommet(True, n)

    #creation de l'arbre :
    aFaire = []
    aFaire.append(racine)

    while not aFaire == []:
        # on recupere le sommet courant de aFaire
        courant = aFaire[0]

        # on ajoute ses fils possibles a l'arbre
        # et on les ajoute a aFaire
        for i in [1,2,3]:
            if retraitLegal(courant.n, i):
                new = creerSommet(not courant.IA, courant.n-i) 
                ajouterFils(courant, new)
                aFaire.append(new)

        # on supprime le sommet courant de aFaire (ses fils sont dans l'arbre)
        aFaire.remove (courant)

    
    #afficher(racine)

    evaluation(racine)

    afficher(racine)
    if racine.evaluation == 1:
        print "je vais gagner !"
    else:
        print "je perds si tu joues bien"

    # Choix du truc a jouer :
    evaluationFils = []
    for f in racine.fils:
        evaluationFils.append(f.evaluation)

    #qui est le meilleur fils ?
    maxi = max(evaluationFils)
    imax = evaluationFils.index(maxi)

    # Combien faut il retirer pour arriver dessus ?
    aVirer = racine.n - racine.fils[imax].n
    return aVirer


#   retirer test allumettes sur les n restantes
def retraitLegal(n,test):
    if test <=3 and test >=1 and test <= n:
        return True
    return False

