#-*- coding:utf-8 -*-

import IAallumettes as myIA

# fonction qui verifie si l'on peut bien
#   retirer k allumettes sur les n restantes
def retraitLegal(n,k):
    if k <=3 and k >=1 and k <= n:
        return True
    return False

# Fonction qui retourne le nombre d'allumettes
#    que le joueur actuel veut retirer
#       Si sa réponse est non légale, elle lui redemande jusqu'a un resultat légal.
def demander(numJoueur, joueursIA, n) :
    print "Joueur ", numJoueur+1, " a vous !"
    
    if not joueursIA[numJoueur] : # si le joueur est humain, on lui demande de choisir
        # Mais on va verifier qu'il ne triche pas !
        correct = False
        while not correct:
            test = input("Entrez un chiffre entre 1 et 3, et plus petit que le nombre d'allumettes encore présentes ")
            if retraitLegal(n, test):
                correct = True

        return test
    else :       # sinon, le programme joue.
        # le programme reflechit... et renvoie une réponse.
        return myIA.IA1(n)


# Fonction qui affiche les allumettes restantes...
def afficher(n):
    print "--------PLATEAU----------"
    for i in range(n):
        print 'I',          # la virgule a la fin du print evite le retour a la ligne du print
    print ''
    print "-------------------------"


# programme principal
# ------------------------------

n = 10 # nombre d'allumettes initiales

numJoueur = 0 # c'est au premier joueur de Jouer (ce nombre alternera entre 0 et 1)

# parametrage des IA :
#      [False, False] donne deux joueurs humains.
#      [True, False] donne le premier joueur IA et le second joueur humain.
#      [False, True] donne le premier joueur humain et le second joueur IA
#      [True, True] donne deux joueurs IA
joueursIA = [False, False] # changez le si vous voulez...

# Boucle principale : on s'arretera quand il n'y a plus d'allumettes
while not n == 0 :
    afficher (n)    # On affiche les allumettes restantes.
    aVirer = demander(numJoueur, joueursIA, n) # On demande au joueur combien il veut en retirer
    n = n-aVirer    # On les retire..
    print aVirer, " allumettes retirees"
    numJoueur =  (numJoueur+1) %2   # On change de joueur (0 -> 1 ou 1-> 0)

# Il n'y a plus d'allumettes sur le plateau.
# Le joueur devant jouer a gagné (le précédent a retiré la derniere allumette)
print "Joueur ", numJoueur+1, " a gagné"


